> ## Documentation Index
> Fetch the complete documentation index at: https://docs.buildwithchirp.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create app webhook

> Create a new webhook for the app



## OpenAPI

````yaml /openapi.json post /v1/webhooks
openapi: 3.1.0
info:
  version: 1.0.0
  title: Chirp API
  description: Communication APIs for SMS, MMS, and WhatsApp messaging
servers:
  - url: https://api.buildwithchirp.com
security: []
paths:
  /v1/webhooks:
    post:
      tags:
        - App
        - Webhooks
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateWebhookRequest'
      responses:
        '201':
          description: Create a new webhook
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/WebhookResponse'
                  - properties:
                      id:
                        type: string
                        pattern: ^whk_(?:test_)?[a-zA-Z0-9]{27}$
                        example: whk_2DbBs7GWhGvVNJGrDXr5RG0mBWI
                        description: >-
                          Unique identifier for a Webhook. Format:
                          whk_[test_]{ksuid}
                      appId:
                        type: string
                        pattern: ^app_(?:test_)?[a-zA-Z0-9]{27}$
                        example: app_2DbBs7GWhGvVNJGrDXr5RG0mBWI
                        description: >-
                          Unique identifier for a App. Format:
                          app_[test_]{ksuid}
                      url:
                        type: string
                        format: uri
                        example: https://example.com/webhook
                        description: URL to send webhook events to
                      events:
                        type: array
                        items:
                          type: string
                        example:
                          - messages.sms.received
                          - messages.whatsapp.sent
                        description: Events that trigger this webhook
                      headers:
                        type:
                          - object
                          - 'null'
                        additionalProperties:
                          type: string
                        example:
                          X-Custom-Header: value
                        description: Custom headers included in webhook requests
                      createdAt:
                        type: string
                        format: date-time
                        example: '2021-08-01T00:00:00Z'
                        description: When the webhook was created
                      updatedAt:
                        type: string
                        format: date-time
                        example: '2021-08-01T00:00:00Z'
                        description: When the webhook was last updated
        '400':
          description: Invalid request parameters
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiError'
        '401':
          description: Missing or invalid API key
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiError'
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiError'
      security:
        - appAuth: []
components:
  schemas:
    CreateWebhookRequest:
      type: object
      properties:
        url:
          type: string
          format: uri
          example: https://example.com/webhook
          description: URL to send webhook events to
        events:
          type: array
          items:
            type: string
            enum:
              - messages.sms.received
              - messages.sms.sent
              - messages.sms.delivered
              - messages.sms.failed
              - messages.whatsapp.received
              - messages.whatsapp.sent
              - messages.whatsapp.delivered
              - messages.whatsapp.read
              - messages.whatsapp.failed
              - templates.whatsapp.created
              - templates.whatsapp.updated
              - templates.whatsapp.deleted
              - templates.whatsapp.connected
              - contacts.whatsapp.created
              - contacts.whatsapp.updated
              - contacts.whatsapp.deleted
              - whatsapp.account.connected
              - whatsapp.account.disconnected
          example:
            - messages.sms.sent
            - messages.whatsapp.sent
          description: >-
            Events to trigger webhook. Use messages.sms.* for SMS/MMS events, or
            messages.whatsapp.* for WhatsApp events.
        headers:
          type: object
          additionalProperties:
            type: string
          example:
            X-Custom-Header: value
          description: Custom headers to include in webhook requests
      required:
        - url
        - events
    WebhookResponse:
      type: object
      properties:
        id:
          type: string
          pattern: ^whk_(?:test_)?[a-zA-Z0-9]{27}$
          example: whk_2DbBs7GWhGvVNJGrDXr5RG0mBWI
          description: 'Unique identifier for a Webhook. Format: whk_[test_]{ksuid}'
        appId:
          type: string
          pattern: ^app_(?:test_)?[a-zA-Z0-9]{27}$
          example: app_2DbBs7GWhGvVNJGrDXr5RG0mBWI
          description: 'Unique identifier for a App. Format: app_[test_]{ksuid}'
        url:
          type: string
          format: uri
          example: https://example.com/webhook
          description: URL to send webhook events to
        events:
          type: array
          items:
            type: string
          example:
            - messages.sms.sent
            - messages.whatsapp.sent
          description: Events that trigger this webhook
        headers:
          type:
            - object
            - 'null'
          additionalProperties:
            type: string
          example:
            X-Custom-Header: value
          description: Custom headers included in webhook requests
        createdAt:
          type: string
          format: date-time
          example: '2021-08-01T00:00:00Z'
          description: When the webhook was created
        updatedAt:
          type: string
          format: date-time
          example: '2021-08-01T00:00:00Z'
          description: When the webhook was last updated
      required:
        - id
        - appId
        - url
        - events
        - headers
        - createdAt
        - updatedAt
    ApiError:
      type: object
      properties:
        error:
          type: object
          properties:
            type:
              type: string
              enum:
                - invalid_request_error
                - authentication_error
                - provider_error
                - api_error
              description: The type of error returned
              example: invalid_request_error
            code:
              type: string
              enum:
                - message_undeliverable
                - conversation_window_expired
                - recipient_not_on_whatsapp
                - phone_number_not_assigned
                - unsupported_message_type
                - media_too_large
                - invalid_phone_number
                - template_not_found
                - template_parameter_mismatch
                - groups_not_eligible
                - account_restricted
                - display_name_not_approved
                - whatsapp_not_configured
                - meta_api_error
                - meta_api_unavailable
                - telnyx_api_error
                - telnyx_api_unavailable
                - rate_limit_exceeded
                - whatsapp_rate_limited
                - resource_already_exists
                - test_app_required
                - call_not_found
                - call_already_ended
                - call_failed
                - call_rejected
                - call_timeout
                - call_busy
                - calling_not_configured
                - calling_disabled
                - max_concurrent_calls_reached
                - recording_not_found
                - recording_already_in_progress
                - recording_failed
                - voicemail_not_found
                - voicemail_disabled
                - invalid_call_command
                - command_not_applicable
                - whatsapp_calling_not_enabled
                - whatsapp_call_permission_required
                - whatsapp_call_permission_limit
                - whatsapp_pstn_bridge_forbidden
                - livekit_api_error
                - livekit_room_error
                - sip_trunk_error
              description: A machine-readable error code for programmatic handling
              example: invalid_phone_number
            message:
              type: string
              description: Human-readable error message
              example: The phone number "+1abc" is not in E.164 format.
            doc_url:
              type: string
              format: uri
              description: URL to documentation for this error code
              example: >-
                https://docs.buildwithchirp.com/api_reference/error-codes#invalid_phone_number
            param:
              type: string
              description: The parameter that caused the error
              example: from
            provider:
              $ref: '#/components/schemas/ProviderError'
            additional_info:
              type: array
              items:
                type: string
              description: Human-readable remediation hints (e.g. from Meta Health Status).
          required:
            - type
            - message
      required:
        - error
    ProviderError:
      type: object
      properties:
        source:
          type: string
          enum:
            - meta
            - telnyx
            - livekit
          description: Provider name
          example: meta
        code:
          anyOf:
            - type: number
            - type: string
          description: Provider's native error code
        message:
          type: string
          description: Provider's error message
        fbtrace_id:
          type: string
          description: Meta's trace ID for support tickets
        health_status:
          $ref: '#/components/schemas/HealthStatusPayload'
      required:
        - source
        - code
        - message
    HealthStatusPayload:
      type: object
      properties:
        can_send_message:
          type: string
          enum:
            - AVAILABLE
            - LIMITED
            - BLOCKED
          description: Meta Health Status value
        entities:
          type: array
          items:
            $ref: '#/components/schemas/HealthStatusEntity'
      required:
        - can_send_message
        - entities
      description: >-
        Meta Health Status payload, present when the error was enriched via the
        Health Status API.
    HealthStatusEntity:
      oneOf:
        - type: object
          properties:
            entity_type:
              type: string
              enum:
                - PHONE_NUMBER
                - MESSAGE_TEMPLATE
                - WABA
                - BUSINESS
                - APP
            id:
              type: string
            can_send_message:
              type: string
              enum:
                - AVAILABLE
            can_receive_call_sip:
              type: string
              enum:
                - AVAILABLE
                - LIMITED
                - BLOCKED
              description: Meta Health Status value
            errors:
              type: array
              items:
                $ref: '#/components/schemas/HealthStatusError'
          required:
            - entity_type
            - id
            - can_send_message
        - type: object
          properties:
            entity_type:
              type: string
              enum:
                - PHONE_NUMBER
                - MESSAGE_TEMPLATE
                - WABA
                - BUSINESS
                - APP
            id:
              type: string
            can_send_message:
              type: string
              enum:
                - LIMITED
            can_receive_call_sip:
              type: string
              enum:
                - AVAILABLE
                - LIMITED
                - BLOCKED
              description: Meta Health Status value
            additional_info:
              type: array
              items:
                type: string
            errors:
              type: array
              items:
                $ref: '#/components/schemas/HealthStatusError'
          required:
            - entity_type
            - id
            - can_send_message
            - additional_info
        - type: object
          properties:
            entity_type:
              type: string
              enum:
                - PHONE_NUMBER
                - MESSAGE_TEMPLATE
                - WABA
                - BUSINESS
                - APP
            id:
              type: string
            can_send_message:
              type: string
              enum:
                - BLOCKED
            can_receive_call_sip:
              type: string
              enum:
                - AVAILABLE
                - LIMITED
                - BLOCKED
              description: Meta Health Status value
            errors:
              type: array
              items:
                $ref: '#/components/schemas/HealthStatusError'
          required:
            - entity_type
            - id
            - can_send_message
            - errors
    HealthStatusError:
      type: object
      properties:
        error_code:
          type: number
        error_description:
          type: string
        possible_solution:
          type: string
      required:
        - error_code
        - error_description
        - possible_solution
  securitySchemes:
    appAuth:
      type: http
      scheme: bearer
      description: >-
        App API key (format: sk_live_app_* or sk_test_app_*) for app-level
        operations

````